// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Properties of ExpressRouteServiceProvider
    /// </summary>
    public partial class ExpressRouteServiceProviderPropertiesFormat
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ExpressRouteServiceProviderPropertiesFormat class.
        /// </summary>
        public ExpressRouteServiceProviderPropertiesFormat() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ExpressRouteServiceProviderPropertiesFormat class.
        /// </summary>
        public ExpressRouteServiceProviderPropertiesFormat(IList<string> peeringLocations = default(IList<string>), IList<ExpressRouteServiceProviderBandwidthsOffered> bandwidthsOffered = default(IList<ExpressRouteServiceProviderBandwidthsOffered>), string provisioningState = default(string))
        {
            PeeringLocations = peeringLocations;
            BandwidthsOffered = bandwidthsOffered;
            ProvisioningState = provisioningState;
        }

        /// <summary>
        /// Gets or list of peering locations
        /// </summary>
        [JsonProperty(PropertyName = "peeringLocations")]
        public IList<string> PeeringLocations { get; set; }

        /// <summary>
        /// Gets or bandwidths offered
        /// </summary>
        [JsonProperty(PropertyName = "bandwidthsOffered")]
        public IList<ExpressRouteServiceProviderBandwidthsOffered> BandwidthsOffered { get; set; }

        /// <summary>
        /// Gets or sets Provisioning state of the resource
        /// </summary>
        [JsonProperty(PropertyName = "provisioningState")]
        public string ProvisioningState { get; set; }

    }
}
