// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.OperationalInsights.Models;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Workspace properties.
    /// </summary>
    public partial class WorkspaceProperties
    {
        private System.Guid? _customerId;
        
        /// <summary>
        /// Optional. Gets or sets the ID associated with the workspace.
        /// Setting this value at creation time allows the workspace being
        /// created to be linked to an existing workspace.
        /// </summary>
        public System.Guid? CustomerId
        {
            get { return this._customerId; }
            set { this._customerId = value; }
        }
        
        private string _portalUrl;
        
        /// <summary>
        /// Optional. Gets or sets the URL of the Operational Insights portal
        /// for this workspace.  This value is set on the service side and
        /// read-only on the client side.
        /// </summary>
        public string PortalUrl
        {
            get { return this._portalUrl; }
            set { this._portalUrl = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the provisioning state of the workspace.
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private Sku _sku;
        
        /// <summary>
        /// Optional. Gets or sets the SKU of the workspace.
        /// </summary>
        public Sku Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        private string _source;
        
        /// <summary>
        /// Optional. Gets or set the source of the workspace.  Source defines
        /// where the workspace was created. 'Azure' implies it was created in
        /// Azure.  'External' implies it was created via the Operational
        /// Insights Portal. This value is set on the service side and
        /// read-only on the client side.
        /// </summary>
        public string Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WorkspaceProperties class.
        /// </summary>
        public WorkspaceProperties()
        {
        }
    }
}
