// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Specifies the values to use to join the virtual machine to the domain.
    /// </summary>
    public partial class DomainJoinCredentials
    {
        private string _domain;
        
        /// <summary>
        /// Optional. Specifies the name of the domain used to authenticate an
        /// account. The value is a fully qualified DNS domain. If the domains
        /// name is not specified, Username must specify the user principal
        /// name (UPN) format (user@fully-qualified-DNS-domain) or the
        /// fully-qualified-DNS-domain\\username format. Example: example.com.
        /// </summary>
        public string Domain
        {
            get { return this._domain; }
            set { this._domain = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Required. Specifies the password to use to join the domain.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Required. Specifies a user name in the domain that can be used to
        /// join the domain.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DomainJoinCredentials class.
        /// </summary>
        public DomainJoinCredentials()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the DomainJoinCredentials class with
        /// required arguments.
        /// </summary>
        public DomainJoinCredentials(string userName, string password)
            : this()
        {
            if (userName == null)
            {
                throw new ArgumentNullException("userName");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            this.UserName = userName;
            this.Password = password;
        }
    }
}
