// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.Sql.Models;

namespace Microsoft.WindowsAzure.Management.Sql
{
    /// <summary>
    /// Contains operations for getting Azure SQL Databases that can be
    /// recovered.
    /// </summary>
    public partial interface IRecoverableDatabaseOperations
    {
        /// <summary>
        /// Returns information about a recoverable Azure SQL Database.
        /// </summary>
        /// <param name='serverName'>
        /// The name of the Azure SQL Database Server on which the database was
        /// hosted.
        /// </param>
        /// <param name='databaseName'>
        /// The name of the recoverable Azure SQL Database to be obtained.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Contains the response to the Get Recoverable Database request.
        /// </returns>
        Task<RecoverableDatabaseGetResponse> GetAsync(string serverName, string databaseName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Returns a collection of databases that can be recovered from a
        /// specified server.
        /// </summary>
        /// <param name='serverName'>
        /// The name of the Azure SQL Database Server on which the databases
        /// were hosted.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Contains the response to the List Recoverable Databases request.
        /// </returns>
        Task<RecoverableDatabaseListResponse> ListAsync(string serverName, CancellationToken cancellationToken);
    }
}
