// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Sql.Models;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Contains the response to a Get Database Event Logs request.
    /// </summary>
    public partial class DatabaseGetEventLogsResponse : AzureOperationResponse, IEnumerable<DatabaseEventLog>
    {
        private IList<DatabaseEventLog> _eventLogs;
        
        /// <summary>
        /// Optional. Gets or sets the collection of Azure SQL Database event
        /// logs.
        /// </summary>
        public IList<DatabaseEventLog> EventLogs
        {
            get { return this._eventLogs; }
            set { this._eventLogs = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseGetEventLogsResponse
        /// class.
        /// </summary>
        public DatabaseGetEventLogsResponse()
        {
            this.EventLogs = new LazyList<DatabaseEventLog>();
        }
        
        /// <summary>
        /// Gets the sequence of EventLogs.
        /// </summary>
        public IEnumerator<DatabaseEventLog> GetEnumerator()
        {
            return this.EventLogs.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of EventLogs.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
