// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents the details for backup schedules & volumes under
    /// the backup policy.
    /// </summary>
    public partial class BackupPolicyDetails : BackupPolicy
    {
        private IList<BackupScheduleDetails> _backupSchedules;
        
        /// <summary>
        /// Required. The backup schedules under this backup policy.
        /// </summary>
        public IList<BackupScheduleDetails> BackupSchedules
        {
            get { return this._backupSchedules; }
            set { this._backupSchedules = value; }
        }
        
        private IList<VolumePolicyInfo> _volumes;
        
        /// <summary>
        /// Required. The list of virtual disks under this backup policy.
        /// </summary>
        public IList<VolumePolicyInfo> Volumes
        {
            get { return this._volumes; }
            set { this._volumes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BackupPolicyDetails class.
        /// </summary>
        public BackupPolicyDetails()
        {
            this.BackupSchedules = new List<BackupScheduleDetails>();
            this.Volumes = new List<VolumePolicyInfo>();
        }
    }
}
