// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Represents a volume as present in a backup snapshot
    /// </summary>
    public partial class DRVolume
    {
        private string _displayName;
        
        /// <summary>
        /// Required. The display name
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private long _size;
        
        /// <summary>
        /// Required. Size of the snapshot
        /// </summary>
        public long Size
        {
            get { return this._size; }
            set { this._size = value; }
        }
        
        private string _snapshotId;
        
        /// <summary>
        /// Required. The snapshot identifier
        /// </summary>
        public string SnapshotId
        {
            get { return this._snapshotId; }
            set { this._snapshotId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DRVolume class.
        /// </summary>
        public DRVolume()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the DRVolume class with required
        /// arguments.
        /// </summary>
        public DRVolume(string displayName, long size, string snapshotId)
            : this()
        {
            if (displayName == null)
            {
                throw new ArgumentNullException("displayName");
            }
            if (snapshotId == null)
            {
                throw new ArgumentNullException("snapshotId");
            }
            this.DisplayName = displayName;
            this.Size = size;
            this.SnapshotId = snapshotId;
        }
    }
}
