// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Migration plan for a specific data container
    /// </summary>
    public partial class MigrationPlanInfo
    {
        private int _assumedBandwidthInMbps;
        
        /// <summary>
        /// Required. Gets or sets bandwidth assumed for calculating time for
        /// migration in MBps
        /// </summary>
        public int AssumedBandwidthInMbps
        {
            get { return this._assumedBandwidthInMbps; }
            set { this._assumedBandwidthInMbps = value; }
        }
        
        private string _dataContainerName;
        
        /// <summary>
        /// Required. Gets or sets the name of the data container
        /// </summary>
        public string DataContainerName
        {
            get { return this._dataContainerName; }
            set { this._dataContainerName = value; }
        }
        
        private int _estimatedTimeInMinutes;
        
        /// <summary>
        /// Required. Gets or sets the estimated Time for all back ups to be
        /// migrated (In minutes)
        /// </summary>
        public int EstimatedTimeInMinutes
        {
            get { return this._estimatedTimeInMinutes; }
            set { this._estimatedTimeInMinutes = value; }
        }
        
        private int _estimatedTimeInMinutesForLargestBackup;
        
        /// <summary>
        /// Required. Gets or sets estimated time for largest backup to be
        /// migrated (In minutes)
        /// </summary>
        public int EstimatedTimeInMinutesForLargestBackup
        {
            get { return this._estimatedTimeInMinutesForLargestBackup; }
            set { this._estimatedTimeInMinutesForLargestBackup = value; }
        }
        
        private IList<HcsMessageInfo> _planMessageInfoList;
        
        /// <summary>
        /// Required. Gets or sets the list message and recommendation returned
        /// based on the estimation being done
        /// </summary>
        public IList<HcsMessageInfo> PlanMessageInfoList
        {
            get { return this._planMessageInfoList; }
            set { this._planMessageInfoList = value; }
        }
        
        private MigrationPlanStatus _planStatus;
        
        /// <summary>
        /// Required. Gets or sets the status of migration plan
        /// </summary>
        public MigrationPlanStatus PlanStatus
        {
            get { return this._planStatus; }
            set { this._planStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MigrationPlanInfo class.
        /// </summary>
        public MigrationPlanInfo()
        {
            this.PlanMessageInfoList = new LazyList<HcsMessageInfo>();
        }
    }
}
