// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Info about the async task
    /// </summary>
    public partial class TaskStatusInfo : AzureOperationResponse
    {
        private AsyncTaskAggregatedResult _asyncTaskAggregatedResult;
        
        /// <summary>
        /// Required. The result of the task
        /// </summary>
        public AsyncTaskAggregatedResult AsyncTaskAggregatedResult
        {
            get { return this._asyncTaskAggregatedResult; }
            set { this._asyncTaskAggregatedResult = value; }
        }
        
        private ErrorDetails _error;
        
        /// <summary>
        /// Required. Error details for task's failures
        /// </summary>
        public ErrorDetails Error
        {
            get { return this._error; }
            set { this._error = value; }
        }
        
        private AsyncTaskResult _result;
        
        /// <summary>
        /// Required. Task's result
        /// </summary>
        public AsyncTaskResult Result
        {
            get { return this._result; }
            set { this._result = value; }
        }
        
        private AsyncTaskStatus _status;
        
        /// <summary>
        /// Required. Task's status
        /// </summary>
        public AsyncTaskStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private string _taskId;
        
        /// <summary>
        /// Required. Task's id
        /// </summary>
        public string TaskId
        {
            get { return this._taskId; }
            set { this._taskId = value; }
        }
        
        private IList<TaskStep> _taskSteps;
        
        /// <summary>
        /// Required. List of steps which are part of the task, with each
        /// step's status
        /// </summary>
        public IList<TaskStep> TaskSteps
        {
            get { return this._taskSteps; }
            set { this._taskSteps = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TaskStatusInfo class.
        /// </summary>
        public TaskStatusInfo()
        {
            this.TaskSteps = new List<TaskStep>();
        }
    }
}
