// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.StorSimple;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple
{
    /// <summary>
    /// This is an RESTFul API to manage you StorSimple Objects
    /// </summary>
    public static partial class VirtualDiskOperationsExtensions
    {
        /// <summary>
        /// The Begin Creating Volume operation creates a new volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the Create virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static GuidTaskResponse BeginCreating(this IVirtualDiskOperations operations, string deviceId, VirtualDiskRequest diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).BeginCreatingAsync(deviceId, diskDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Begin Creating Volume operation creates a new volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the Create virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static Task<GuidTaskResponse> BeginCreatingAsync(this IVirtualDiskOperations operations, string deviceId, VirtualDiskRequest diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.BeginCreatingAsync(deviceId, diskDetails, customRequestHeaders, CancellationToken.None);
        }
        
        /// <summary>
        /// The Begin Deleteing Volume operation deletes the specified volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. Instance id of the virtual disk to be deleted.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static GuidTaskResponse BeginDeleting(this IVirtualDiskOperations operations, string deviceId, string diskId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).BeginDeletingAsync(deviceId, diskId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Begin Deleteing Volume operation deletes the specified volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. Instance id of the virtual disk to be deleted.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static Task<GuidTaskResponse> BeginDeletingAsync(this IVirtualDiskOperations operations, string deviceId, string diskId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.BeginDeletingAsync(deviceId, diskId, customRequestHeaders, CancellationToken.None);
        }
        
        /// <summary>
        /// The Begin updating Volume operation updates an existing volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the update virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static GuidTaskResponse BeginUpdating(this IVirtualDiskOperations operations, string deviceId, string diskId, VirtualDisk diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).BeginUpdatingAsync(deviceId, diskId, diskDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Begin updating Volume operation updates an existing volume.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the update virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static Task<GuidTaskResponse> BeginUpdatingAsync(this IVirtualDiskOperations operations, string deviceId, string diskId, VirtualDisk diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.BeginUpdatingAsync(deviceId, diskId, diskDetails, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the Create virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static TaskStatusInfo Create(this IVirtualDiskOperations operations, string deviceId, VirtualDiskRequest diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).CreateAsync(deviceId, diskDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the Create virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static Task<TaskStatusInfo> CreateAsync(this IVirtualDiskOperations operations, string deviceId, VirtualDiskRequest diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.CreateAsync(deviceId, diskDetails, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static TaskStatusInfo Delete(this IVirtualDiskOperations operations, string deviceId, string diskId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).DeleteAsync(deviceId, diskId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static Task<TaskStatusInfo> DeleteAsync(this IVirtualDiskOperations operations, string deviceId, string diskId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.DeleteAsync(deviceId, diskId, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='diskName'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the get of virtual disk.
        /// </returns>
        public static VirtualDiskGetResponse GetByName(this IVirtualDiskOperations operations, string deviceId, string diskName, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).GetByNameAsync(deviceId, diskName, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='diskName'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the get of virtual disk.
        /// </returns>
        public static Task<VirtualDiskGetResponse> GetByNameAsync(this IVirtualDiskOperations operations, string deviceId, string diskName, CustomRequestHeaders customRequestHeaders)
        {
            return operations.GetByNameAsync(deviceId, diskName, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='dataContainerId'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the list of virtual disks for a given data
        /// container.
        /// </returns>
        public static VirtualDiskListResponse List(this IVirtualDiskOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).ListAsync(deviceId, dataContainerId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='dataContainerId'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the list of virtual disks for a given data
        /// container.
        /// </returns>
        public static Task<VirtualDiskListResponse> ListAsync(this IVirtualDiskOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.ListAsync(deviceId, dataContainerId, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the update virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static TaskStatusInfo Update(this IVirtualDiskOperations operations, string deviceId, string diskId, VirtualDisk diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualDiskOperations)s).UpdateAsync(deviceId, diskId, diskDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IVirtualDiskOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='diskId'>
        /// Required. disk id
        /// </param>
        /// <param name='diskDetails'>
        /// Required. Parameters supplied to the update virtual disk operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static Task<TaskStatusInfo> UpdateAsync(this IVirtualDiskOperations operations, string deviceId, string diskId, VirtualDisk diskDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.UpdateAsync(deviceId, diskId, diskDetails, customRequestHeaders, CancellationToken.None);
        }
    }
}
